<?php

namespace Drupal\email_validator;

use Drupal\Core\Form\FormStateInterface;

/**
 * @file
 * Check the email for email_verify module.
 */

/**
 * Email Validation service.
 */
class EVAForms {

  /**
   * Custom validation on forms for 'mail' fields.
   */
  public static function validateCustomForm(array &$form, FormStateInterface $form_state) {
    // Some forms use 'email' instead of mail. So we need to do this validation.
    if (!empty($form_state->getValue('mail'))) {
      $mail_val = $form_state->getValue('mail');
      $mail_field = 'mail';
    }
    elseif (!empty($commerce = $form_state->getValue('contact_information'))) {
      if (!empty($commerce['email'])) {
        $mail_val = $commerce['email'];
        $mail_field = 'contact_information';
      }
    }
    // Check if this mail is valid or not by custom validation.
    if (isset($mail_val)) {
      if (!\Drupal::service('email_validator.eva')->isValid($mail_val, NULL, TRUE)) {
        $form_state->setErrorByName($mail_field, t('The email address @mail is not valid.',
          ['@mail' => $mail_val]
        ));
      }
    }
  }

}
